10  'ͻ
20  '  Program  : THERMO.C                                               
30  '  Revision : 1.0                                                    
40  '  Date     : 11/10/90                        AXIOMTEK Tech. Co., Ltd.  
50  'Ķ
60  '  Purpose  : This demo program perform measuring thermocouple       
70  '             with AX5210 and AX752.                                 
80  'ͼ
90  '
100 'ķ
110 ' SET WORKING SPACE,AND LOAD AX5210 DRIVER 
120 'Ľ
130 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
140 CLEAR,49152!
150 DEF SEG = 0
160 SG = 256 * PEEK(&H511) + PEEK(&H510)
170 SG = SG +49152!/16
180 DEF SEG = SG
190 BLOAD "AX5210.BIN", 0
200 AX5210 = 0			' Driver segment offset
210 DIM DIO%(6)
220 DIM F.TC.R(6,2),F.TC.P(6,9),TC(2)
230 GOSUB 1210			 ' Load thermocouple parameter
240 '
250 'ķ
260 ' FUNCTION NO. DEFINITION 
270 'Ľ
280 INIT%     = 0:SET.CH%   = 1:SET.GAIN% = 2:SFT.TRG% = 3:NADC.ARY% = 4
290 INTR%     = 5:DIS.INTR% = 6:READ.ST%  = 7:TRAN.DAT%= 8
290 SET.TIMER%= 9:TRG.SLOPE%=10:DO.BYTE%  =11:DI.BYTE% =12:NADCG.INT%=13
310 '
320 'ķ
330 ' SUB FUNCTION NO. DEFINITION 
340 'Ľ
350 RISE.EDGE%= 0:FALL.EDGE%= 1:EXT.TRG%  = 0:TIMER.TRG%= 1
360 ONE.CYC%  = 0:RE.CYC%   = 1
370 '
380 'ķ
390 ' INITIAL AX5210 
400 'Ľ
410 FLAG%=0
420 FUN%=INIT%			' Initial function
430 DIO%(0)=&H300		' Ioport set
440 DIO%(1)=3			' IRQ NO.
450 CALL AX5210(FUN%,DIO%(0),FLAG%)
460 IF FLAG% <> 0 THEN PRINT USING "DRIVER INITIALIZATION FAILED,flag=###";FLAG%
465 CLS
470 print
471 print  "1. The demo program performs measuring thermocouple with AX5210 and AX752."
472 print  "2. Please connect AX5210 CN1 TO AX752 CNA .      "
473 print  "3. Please set CJC to channel 0 on JP1 on AX752.      "
474 print  "4. Please set OUT to channel 1 on JP2 on AX752.      "
475 print  "5. Please set GAIN on JP4 on AX752, say, GAIN=200 for k type TC. ."
476 print  "=========================================================================="
480 'ķ
490 ' SET START & STOP CHANNEL 
500 'Ľ
510 FUN%=SET.CH%		' Set channel function
520 DIO%(0)=0			' Start channel set
530 DIO%(1)=1			' Stop  channel set
540 CALL AX5210(FUN%,DIO%(0),FLAG%)
550 IF FLAG% <> 0 THEN PRINT "SET SCAN CHANNEL FAILED ! RE-ENTER"
560 '
570 'ķ
580 ' SET GAIN FOR ALL CHANNEL 
590 'Ľ
600 FOR I%= 0 TO 15
610	FUN%=SET.GAIN%		' Set gain function
620	DIO%(0)=I%		' Channel set
630	DIO%(1)=1		' Gain set
640	CALL AX5210(FUN%,DIO%(0),FLAG%)
650	IF FLAG% <> 0 THEN PRINT "SET GAIN FAILED ! RE-ENTER"
660 NEXT I%
670 '
680 'ķ
690 ' SELECT THERMOCOUPLE CHANNEL IN AX752 
700 'Ľ
710 INPUT   "ENTER THERMOCOUPLE CHANNEL ON AX752 <0.....15>",TC.CH%
715 INPUT   "ENTER GAIN ON AX752 <10, 50, 100, 200, 1000> ",PRE.GAIN%
720 INPUT   "ENTER THERMOCOUPLE TYPE <J,K,T,E,R,S>",F.A$
730 FUN%=DO.BYTE%		' Digit out
740 DIO%(0)=TC.CH%
750 CALL AX5210(FUN%,DIO%(0),FLAG%)
760 IF FLAG% <> 0 THEN PRINT "DIGIT OUT FAILED ! RE-ENTER"
770 '
780 'ķ
790 ' SOFTWARE TRIGGER 
800 'Ľ
810 WHILE (1)
820   FOR I%=0 TO 1
830    FUN%=SFT.TRG%		' Software trigger function
840    CALL AX5210(FUN%,DIO%(0),FLAG%)
850    IF FLAG% <> 0 THEN PRINT "A/D CONVERSION FAILED!"
860    IF DIO%(1)=0 THEN LOCATE 12,1:PRINT USING "COLD JUNCTION : CHANNEL ##  READING ##### " ;DIO%(1);DIO%(0)
870    IF DIO%(1)=1 THEN LOCATE 13,1:PRINT USING "THERMOCOUPLE  : CHANNEL ##  READING ##### " ;DIO%(1);DIO%(0)
880    TC(DIO%(1))=DIO%(0)
890   NEXT I%
900   GOSUB 980
910   LOCATE 14,1:PRINT "MEASURED TEMPERATURE = ",F.DATA
920   PRINT " PRESS ANY KEY TO EXIT "
930   A$=INKEY$
940   IF LEN(A$) <> 0 THEN GOTO 960
950 WEND
960 END
970  '
980  'ķ
990  ' TC temp (JKTERS)                                         
1000 ' COLD JUNCTION TEMPERATURE  DEGREE :F.T0 = Vc/(24.44mV/C) 
1010 'Ľ
1020 F.T0=(TC(0)/2048*5)/.0244
1030 IF INSTR(F.A$,"J")<>0 OR INSTR(F.A$,"j")<>0 THEN F.R%=0
1040 IF INSTR(F.A$,"K")<>0 OR INSTR(F.A$,"k")<>0 THEN F.R%=1
1050 IF INSTR(F.A$,"T")<>0 OR INSTR(F.A$,"t")<>0 THEN F.R%=2
1060 IF INSTR(F.A$,"E")<>0 OR INSTR(F.A$,"e")<>0 THEN F.R%=3
1070 IF INSTR(F.A$,"R")<>0 OR INSTR(F.A$,"r")<>0 THEN F.R%=4
1080 IF INSTR(F.A$,"S")<>0 OR INSTR(F.A$,"s")<>0 THEN F.R%=5
1090 '
1100 'THERMOCOUPLE TEMPERATURE  DEGREE : F.ANS = Vm / (GAIN OF AX752)
1110 F.ANS=(TC(1)/2048*5)/PRE.GAIN%
1120 IF F.ANS>100 OR F.ANS<-100 THEN F.DATA=9999:RETURN
1130 '
1140 ' -----calculate thermocouple degree
1150 YS.V1=F.TC.R(F.R%,0)+F.T0*(F.TC.R(F.R%,1)+F.T0*F.TC.R(F.R%,2))+F.ANS
1160 YS.T1=YS.V1*(F.TC.P(F.R%,5)+YS.V1*(F.TC.P(F.R%,6)+YS.V1*(F.TC.P(F.R%,7)+YS.V1*(F.TC.P(F.R%,8)+YS.V1*F.TC.P(F.R%,9)))))
1170 YS.T2=F.TC.P(F.R%,0)+YS.V1*(F.TC.P(F.R%,1)+YS.V1*(F.TC.P(F.R%,2)+YS.V1*(F.TC.P(F.R%,3)+YS.V1*(F.TC.P(F.R%,4)+YS.T1))))
1180 F.DATA=INT(YS.T2*100+.5)/100
1190 RETURN
1200 '
1210 'ķ
1220 ' read tc temp data 
1230 'Ľ
1240 ' --J type
1250 F.TC.R(0,0)=-.00000075004344#   : F.TC.R(0,1)=.0000505321995#
1260 F.TC.R(0,2)=2.348050017D-08     : F.TC.P(0,0)=-.3595568424#
1270 F.TC.P(0,1)=19750.87948#	     : F.TC.P(0,2)=-175116.54251252#
1280 F.TC.P(0,3)=18212965.58#	     : F.TC.P(0,4)=-2831128435#
1290 F.TC.P(0,5)=271508383300#	     : F.TC.P(0,6)=-13801412100000#
1300 F.TC.P(0,7)=379243843260000#    : F.TC.P(0,8)=-5371925517000000#
1310 F.TC.P(0,9)=3.0840255439D+16
1320 ' --K type
1330 F.TC.R(1,0)=-.0000008167743593# : F.TC.R(1,1)=.00003963927586#
1340 F.TC.R(1,2)=1.640341085D-08     : F.TC.P(1,0)=-.05115307103#
1350 F.TC.P(1,1)=24850.28007#	     : F.TC.P(1,2)=-382662.2822#
1360 F.TC.P(1,3)=99661056.73#	     : F.TC.P(1,4)=-10820623570#
1370 F.TC.P(1,5)=603928552400#	     : F.TC.P(1,6)=-19108999620000#
1380 F.TC.P(1,7)=347823473000000#    : F.TC.P(1,8)=-3399102821000000#
1390 F.TC.P(1,9)=1.382851398D+16
1400 ' --T type
1410 F.TC.R(2,0)=.000000525792984#   : F.TC.R(2,1)=.00003860071243#
1420 F.TC.R(2,2)=4.186486602D-08     : F.TC.P(2,0)=.1238117795#
1430 F.TC.P(2,1)=26861.17637#	     : F.TC.P(2,2)=-896494.288#
1440 F.TC.P(2,3)=-46489260.88#	     : F.TC.P(2,4)=12441142450#
1450 F.TC.P(2,5)=2275304922000#      : F.TC.P(2,6)=-639949686700000#
1460 F.TC.P(2,7)=5.435757807D+16     : F.TC.P(2,8)=-2.02361537D+18
1470 F.TC.P(2,9)=2.830121167D+19
1480 ' --E type
1490 F.TC.R(3,0)=.0000001237730126#  : F.TC.R(3,1)=.00005866024018#
1500 F.TC.R(3,2)=4.545892772D-08     : F.TC.P(3,0)=.2146439563#
1510 F.TC.P(3,1)=16129.94414#	     : F.TC.P(3,2)=-205410.8711#
1520 F.TC.P(3,3)=30494320.13#	     : F.TC.P(3,4)=-2969024265#
1530 F.TC.P(3,5)=142849580700#	     : F.TC.P(3,6)=-3722194380000#
1540 F.TC.P(3,7)=53981272330000#     : F.TC.P(3,8)=-410552947700000#
1550 F.TC.P(3,9)=1277746629000000#
1560 ' --R type
1570 F.TC.R(4,0)=-.0000002112842336# : F.TC.R(4,1)=.000005334025378#
1580 F.TC.R(4,2)=1.195845433D-08     : F.TC.P(4,0)=-1.468841678#
1590 F.TC.P(4,1)=172645.1124#	     : F.TC.P(4,2)=-32766927.31#
1600 F.TC.P(4,3)=7787787267#	     : F.TC.P(4,4)=-1139825933000#
1610 F.TC.P(4,5)=101396298600000#    : F.TC.P(4,6)=-5484260171000000#
1620 F.TC.P(4,7)=1.74144946D+17      : F.TC.P(4,8)=-2.92355047D+18
1630 F.TC.P(4,9)=1.928074475D+19
1640 ' --S type
1650 F.TC.R(5,0)=-.0000002019201233# : F.TC.R(5,1)=.000005442370913#
1660 F.TC.R(5,2)=1.066719241D-08     : F.TC.P(5,0)=-1.374980264#
1670 F.TC.P(5,1)=173544.5798#	     : F.TC.P(5,2)=-32625706.06#
1680 F.TC.P(5,3)=8477335148#	     : F.TC.P(5,4)=-1327039894000#
1690 F.TC.P(5,5)=123611232200000#    : F.TC.P(5,6)=-6792674872000000#
1700 F.TC.P(5,7)=2.068929393D+17     : F.TC.P(5,8)=-2.887484948D+18
1710 F.TC.P(5,9)=8.266372801D+18
1720 RETURN
