{*   ͻ
 *   	Program  : AX5210.INC						  
 *   	Revision : 1.0							  
 *   	Date	 : 03/05/1991			   Axiom Tech. Co., Ltd.  
 *   Ķ
 *   	Purpose  : Include file for AX5210 driver's function number.      
 *   ͼ
 *
 *   ķ
 *    FUNCTION NO. DEFINITION 
 *   Ľ
 *}
CONST
	 INIT	    : INTEGER =     0 ;  { Initial ax5210		      }
	 SET_CH     : INTEGER =     1 ;  { Set channel			      }
	 SET_GAIN   : INTEGER =     2 ;  { Set gain for channel 	      }
	 SFT_TRG    : INTEGER =     3 ;  { 1 Adc s/w trig		      }
	 NADC_ARY   : INTEGER =     4 ;  { N Adc pacer or ext. trig to array  }
	 INTR	    : INTEGER =     5 ;  { N Adc on interrupt		      }
	 DIS_INTR   : INTEGER =     6 ;  { Disable interrupt		      }
	 READ_ST    : INTEGER =     7 ;  { Read intr status		      }
	 TRAN_DAT   : INTEGER =     8 ;  { Transfer data from memory to array }
	 SET_TIMER  : INTEGER =     9 ;  { Set 8254 timer for pacer	      }
	 TRG_SLOPE  : INTEGER =     10;  { Trigger slope setting	      }
	 DO_BYTE    : INTEGER =     11;  { Digit out			      }
	 DI_BYTE    : INTEGER =     12;  { Digit in			      }
	 NADCG_INT  : INTEGER =     13;  { N Adc Group collecting on interrupt}
   { ķ
      SUB FUNCTION NO. DEFINITION 
     Ľ }
	 RISE_EDGE  : INTEGER =     0 ;  { Rising edge mode		      }
	 FALL_EDGE  : INTEGER =     1 ;  { Falling edge mode		      }
	 EXT_TRG    : INTEGER =     0 ;  { External trigger mode	      }
	 TIMER_TRG  : INTEGER =     1 ;  { Pacer trigger mode		      }
	 ONE_CYC    : INTEGER =     0 ;  { One cycle			      }
	 RE_CYC     : INTEGER =     1 ;  { Recycle			      }
