{*   ͻ
 *   	Program  : DIR_IO.PAS						  
 *   	Revision : 1.0							  
 *   	Date	 : 11/10/90			   AXIOMTEK Tech. Co., Ltd.  
 *   Ķ
 *   	Purpose  : This demo program perform one channel A/D conversion   
 *   		   on software trigger by controling I/O port directly.   
 *   ͼ
 *}

PROGRAM 	DIR_IO;
USES		CRT;
VAR
	IOPORT, START_CH, STOP_CH, CH, DAT, DAT_H, DAT_L, I , J:INTEGER;
	CHA: CHAR;

BEGIN
	CLRSCR;
	IOPORT := $300;

 { ķ
    INITIAL AX5210	
   Ľ }
	PORT[IOPORT+2] := 1;	  { Write 0x01 pattern to control register }
	i := PORT[IOPORT+2];
	if (i = 1) THEN WRITELN('AX5210 NOT EXIST');
	PORT[IOPORT+2] := 2;	  { Write 0x01 pattern to control register }
	i := PORT[IOPORT+2];
	if (i = 2) THEN WRITELN('AX5210 NOT EXIST');

 { ķ
    SET START & STOP CHANNEL 
   Ľ }
	WRITE('ENTER START CHANNEL NUMBER <S/E--0...15>');
	READLN(start_ch);
	WRITE('ENTER STOP  CHANNEL NUMBER <S/E--0...15>');
	READLN(stop_ch);
	j := start_ch;
	PORT[IOPORT+2] := 0;   { enable software trigger mode }

 { ķ
    SOFTWARE TRIGGER 
   Ľ }
	REPEAT
	   PORT[IOPORT+1] := j;    {  set channel }
	   for i := 0 TO 1000 DO;
	   PORT[IOPORT] := 0;	   {  software trigger }
	   while ((PORT[IOPORT+2] AND $08) <> 0) DO;	{ EOC = 0 ADC ready }
	   dat_l := PORT[IOPORT];
	   dat_h := PORT[IOPORT+1];
	   ch := (dat_l AND $0F);
	   dat := (dat_h SHL 4) + (dat_l SHR 4);
	   dat := dat - 2048;
	   WRITELN('     CHANNEL ', CH:2,' READING ', dat:5);
	   WRITELN(' PRESS ANY KEY TO CONVERT ANOTHER CHANNEL, <e> OR <E> TO EXIT ');
	   J := J + 1;
	   if (j > stop_ch) THEN j := start_ch;
	   CHA := READKEY
	UNTIL (CHA = 'E') OR (CHA = 'e') ;
END.
