{*   ͻ
 *   	Program  : SFT_TRG.PAS						  
 *   	Revision : 1.0							  
 *   	Date	 : 03/05/1991			   AXIOMTEK Tech. Co., Ltd.  
 *   Ķ
 *   	Purpose  : This demo program perform one channel A/D conversion   
 *   		   with software trigger by function INIT,SET_CH,SET_GAIN 
 *   		   ,SFT_TRG.						  
 *   ͼ
 *}

PROGRAM 	SFTTRG;
USES		CRT;
{$L  AX5210P.OBJ}
{$I  AX5210.INC}
TYPE	X=ARRAY[1..10] OF INTEGER;

VAR
	DIO:X;
	FLAG,FUN:INTEGER;
	START_CH, STOP_CH, I:INTEGER;
	CHA :CHAR;

FUNCTION	AX5210(FUN:INTEGER;VAR DIO:X):INTEGER;EXTERNAL;

BEGIN
	CLRSCR;
 { ķ
    INITIALIZE AX5210	
   Ľ }
	FUN := INIT;
	DIO[1] := $300;
	DIO[2] := 3;
	FLAG := AX5210(FUN,DIO);
	IF FLAG <> 0 THEN
	   BEGIN
	    WRITELN('AX5210 INITIALIZE ERROR FLAG = ',FLAG);
	    EXIT
	   END;

 { ķ
    SET START & STOP CHANNEL 
   Ľ }
	WRITE('ENTER START CHANNEL NUMBER <S/E--0...15>');
	READLN(start_ch);
	WRITE('ENTER STOP  CHANNEL NUMBER <S/E--0...15>');
	READLN(stop_ch);

	fun := SET_CH;		   { Set channel function   }
	dio[1] := start_ch;	   { Start channel set	    }
	dio[2] := stop_ch;	   { Stop  channel set	    }
	flag := ax5210(fun,dio);
	if (flag <> 0 ) THEN WRITELN('SET SCAN CHANNEL FAILED ! RE-ENTER');

 { ķ
    SET GAIN FOR ALL CHANNEL 
   Ľ }
	for i:=0 TO 15 DO
	    BEGIN
		fun := SET_GAIN;      { Set gain function   }
		dio[1] := i;	   { Set channel	 }
		dio[2] := 1;	   { Set gain		 }
		flag := ax5210(fun,dio);
		if (flag <> 0) THEN WRITELN('SET GAIN FAIL')
	    END;

 { ķ
    SOFTWARE TRIGGER 
   Ľ }
	REPEAT
	   fun := SFT_TRG;	   { Software trigger function }
	   flag := ax5210(fun,dio);
	   if (flag <> 0) THEN WRITELN('SOFT WARE TRIGGER FAIL');
	   WRITELN('     CHANNEL ', DIO[2]:2, '  DATA   ', dio[1]:5);
	   WRITELN(' PRESS ANY KEY TO CONVERT NEXT CHANNEL, <e> OR <E> TO EXIT ');
	   CHA := READKEY;
	UNTIL (CHA = 'e') OR (CHA = 'E');
END.
