10  'ͻ
20  '  Program  : INTR.BAS                                               
30  '  Revision : 1.0                                                    
40  '  Date     : 11/10/90                        AXIOMTEK Tech. Co., Ltd.  
50  'Ķ
60  '  Purpose  : This demo program perform N channel A/D conversion with
70  '             Interrupt by function INIT%,SET.CH%,SET.GAIN%,         
80  '             SET.TIMER%,INTR%,READ.ST%,DIS.INTR%,TRAN.DAT%.         
90  'ͼ
100 '
110 'ķ
120 ' SET WORKING SPACE,AND LOAD AX5210 DRIVER 
130 'Ľ
140 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
150 CLEAR,49152!
160 DEF SEG = 0
170 SG = 256 * PEEK(&H511) + PEEK(&H510)
180 SG = SG +49152!/16
190 DEF SEG = SG
200 BLOAD "AX5210.BIN", 0
210 AX5210 = 0			' Driver segment offset
220 DIM DIO%(6),CH%(200),DAT%(200)
230 '
240 'ķ
250 ' FUNCTION NO. DEFINITION 
260 'Ľ
270 INIT%     = 0:SET.CH%   = 1:SET.GAIN% = 2:SFT.TRG% = 3:NADC.ARY% = 4
280 INTR%     = 5:DIS.INTR% = 6:READ.ST%  = 7:TRAN.DAT%= 8
290 SET.TIMER%= 9:TRG.SLOPE%=10:DO.BYTE%  =11:DI.BYTE% =12:NADCG.INT%=13
300 '
310 'ķ
320 ' SUB FUNCTION NO. DEFINITION 
330 'Ľ
340 RISE.EDGE%= 0:FALL.EDGE%= 1:EXT.TRG%  = 0:TIMER.TRG%= 1
350 ONE.CYC%  = 0:RE.CYC%   = 1
360 '
370 'ķ
380 ' INITIAL AX5210 
390 'Ľ
400 FLAG%=0
410 FUN%=INIT%			' Initial function
420 DIO%(0)=&H300		' Ioport set
430 DIO%(1)=3			' IRQ NO.
440 CALL AX5210(FUN%,DIO%(0),FLAG%)
450 IF FLAG% <> 0 THEN PRINT USING "DRIVER INITIALIZATION FAILED,flag=###";FLAG%
460 '
470 'ķ
480 ' SET START & STOP CHANNEL 
490 'Ľ
500 INPUT   "ENTER START CHANNEL NUMBER <S/E--0...15>",STR%
510 INPUT   "ENTER STOP  CHANNEL NUMBER <S/E--0...15>",STP%
520 FUN%=SET.CH%		' Set channel function
530 DIO%(0)=STR%		' Start channel set
540 DIO%(1)=STP%		' Stop  channel set
550 CALL AX5210(FUN%,DIO%(0),FLAG%)
560 IF FLAG% <> 0 THEN PRINT "SET SCAN CHANNEL FAILED ! RE-ENTER"
570 '
580 'ķ
590 ' SET GAIN FOR ALL CHANNEL 
600 'Ľ
610 FOR I%= 0 TO 15
620	FUN%=SET.GAIN%		' Set gain function
630	DIO%(0)=I%		' Channel set
640	DIO%(1)=1		' Gain set
650	CALL AX5210(FUN%,DIO%(0),FLAG%)
660	IF FLAG% <> 0 THEN PRINT "SET GAIN FAILED ! RE-ENTER"
670 NEXT I%
680 '
690 'ķ
700 ' SET TIMER BEFORE INTERRUPT (MAX RATE=10k) 
710 'Ľ
720 FUN%=SET.TIMER%		' Set timer rate = 1M/(divisor1 * divisor2)
730 DIO%(0)=10			' divisor 1
740 DIO%(1)=20			' divisor 2
750 CALL AX5210(FUN%,DIO%(0),FLAG%)
760 '
770 'ķ
780 ' ENABLE INTERRUPT ACCORDING TO TIMER RATE 
790 'Ľ
800 CNT%=64
810 FUN%=INTR%			' Interrupt function
820 DIO%(0)=CNT%		' Count
830 DIO%(1)=&H8000		' Memory segment
840 DIO%(2)=TIMER.TRG%		' Pacer trigger
850 DIO%(3)=ONE.CYC%		' One cycle
860 CALL AX5210(FUN%,DIO%(0),FLAG%)
870 IF FLAG% <> 0 THEN PRINT "INTERRUPT FAILED FLAG= ####";DIO%(5)
880 '
890 'ķ
900 ' READ INTERRUPT COUNT 
910 'Ľ
920 WHILE (1)
930	 FUN%=READ.ST%	       ' Read Interrupt count function
940	 CALL AX5210(FUN%,DIO%(0),FLAG%)
950	 LOCATE 1,50: PRINT "Intr cnt=####";DIO%(2)
960	 IF DIO%(2) >= CNT% THEN GOTO 990
970 WEND
980  '
990  'ķ
1000 ' DISABLE INTERRUPT 
1010 'Ľ
1020 FUN%=DIS.INTR%		' Disable interrupt
1030 CALL AX5210(FUN%,DIO%(0),FLAG%)
1040 IF FLAG% <> 0 THEN PRINT "INTERRUPT DISABLE FAIL"
1050 '
1060 'ķ
1070 ' TRANSFER DATA FROM MEMORY TO ARRAY 
1080 'Ľ
1090 FUN%=TRAN.DAT%		' Data transfer function
1100 DIO%(0)=CNT%		' Count
1110 DIO%(1)=&H8000		' Data memory segment
1120 DIO%(2)=0			' Starting data number
1130 DIO%(3) = VARPTR(DAT%(0))	' Get data array
1140 DIO%(4) = VARPTR(CH%(0))	' Get channel array
1150 CALL AX5210(FUN%,DIO%(0),FLAG%)
1160 IF FLAG% <> 0 THEN PRINT "data transfer error ! "
1170 CLS
1180 '
1190 'ķ
1200 ' DISPLAY CHANNEL & DATA 
1210 'Ľ
1220  LOCATE 1,1
1230  FOR I=0 TO (CNT%-1)
1240	  PRINT USING " ch=##, data=####";CH%(I);DAT%(I)
1250  NEXT
1260 END
