10  'ͻ
20  '  Program  : SFT_TRG.BAS                                            
30  '  Revision : 1.0                                                    
40  '  Date     : 11/10/90                        AXIOMTEK Tech. Co., Ltd.  
50  'Ķ
60  '  Purpose  : This demo program perform one channel A/D conversion   
70  '             with software trigger by function INIT%,SET.CH%,       
80  '             SET.GAIN%,SFT.TRG%.                                    
90  'ͼ
100 '
110 'ķ
120 ' SET WORKING SPACE,AND LOAD AX5210 DRIVER 
130 'Ľ
140 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
150 CLEAR,49152!
160 DEF SEG = 0
170 SG = 256 * PEEK(&H511) + PEEK(&H510)
180 SG = SG +49152!/16
190 DEF SEG = SG
200 BLOAD "AX5210.BIN", 0
210 AX5210 = 0			' Driver segment offset
220 DIM DIO%(6)
230 '
240 'ķ
250 ' FUNCTION NO. DEFINITION 
260 'Ľ
270 INIT%     = 0:SET.CH%   = 1:SET.GAIN% = 2:SFT.TRG% = 3:NADC.ARY% = 4
280 INTR%     = 5:DIS.INTR% = 6:READ.ST%  = 7:TRAN.DAT%= 8
290 SET.TIMER%= 9:TRG.SLOPE%=10:DO.BYTE%  =11:DI.BYTE% =12:NADCG.INT%=13
300 '
310 'ķ
320 ' SUB FUNCTION NO. DEFINITION 
330 'Ľ
340 RISE.EDGE%= 0:FALL.EDGE%= 1:EXT.TRG%  = 0:TIMER.TRG%= 1
350 ONE.CYC%  = 0:RE.CYC%   = 1
360 '
370 'ķ
380 ' INITIAL AX5210 
390 'Ľ
400 FLAG%=0
410 FUN%=INIT%			' Initial function
420 DIO%(0)=&H300		' Ioport set
430 DIO%(1)=3			' IRQ NO.
440 CALL AX5210(FUN%,DIO%(0),FLAG%)
450 IF FLAG% <> 0 THEN PRINT USING "DRIVER INITIALIZATION FAILED,flag=###";FLAG%
460 '
470 'ķ
480 ' SET START & STOP CHANNEL 
490 'Ľ
500 INPUT   "ENTER START CHANNEL NUMBER <S/E--0...15> = ",STR%
510 INPUT   "ENTER STOP  CHANNEL NUMBER <S/E--0...15> = ",STP%
520 FUN%=SET.CH%		' Set channel function
530 DIO%(0)=STR%		' Start channel set
540 DIO%(1)=STP%		' Stop  channel set
550 CALL AX5210(FUN%,DIO%(0),FLAG%)
560 IF FLAG% <> 0 THEN PRINT "SET SCAN CHANNEL FAILED ! RE-ENTER"
570 '
580 'ķ
590 ' SET GAIN FOR ALL CHANNEL 
600 'Ľ
610 FOR I%= 0 TO 15
620	FUN%=SET.GAIN%		' Set gain function
630	DIO%(0)=I%		' Channel set
640	DIO%(1)=1		' Gain set
650	CALL AX5210(FUN%,DIO%(0),FLAG%)
660	IF FLAG% <> 0 THEN PRINT "SET GAIN FAILED ! RE-ENTER"
670 NEXT I%
680 '
690 'ķ
700 ' SOFTWARE TRIGGER 
710 'Ľ
720 WHILE (1)
730    FUN%=SFT.TRG%		' Software trigger function
740    CALL AX5210(FUN%,DIO%(0),FLAG%)
750    IF FLAG% <> 0 THEN PRINT "A/D CONVERSION FAILED!"
760    PRINT USING " CHANNEL ##  DATA ##### " ;DIO%(1);DIO%(0)
770    INPUT " PRESS ENTER TO CONVERT NEXT CHANNEL, <e> TO EXIT ",A$
780    IF ((A$ = "E") OR (A$ = "e")) THEN GOTO 800
790 WEND
800 END
