/*   ͻ
 *   	Program  : AX5210.H						  
 *   	Revision : 1.0							  
 *   	Date	 : 11/10/90			   AXIOMTEK Tech. Co., Ltd.  
 *   Ķ
 *   	Purpose  : Include file for AX5210 driver			  
 *   ͼ
 *
 *   ķ
 *    FUNCTION NO. DEFINITION 
 *   Ľ
 */
#define 	INIT		0     /* Initial ax5210 */
#define 	SET_CH		1     /* Set channel */
#define 	SET_GAIN	2     /* Set gain for channel */
#define 	SFT_TRG 	3     /* 1 Adc s/w trig */
#define 	NADC_ARY	4     /* N Adc pacer or ext. trig to array */
#define 	INTR		5     /* N Adc on interrupt */
#define 	DIS_INTR	6     /* Disable interrupt */
#define 	READ_ST 	7     /* Read intr status */
#define 	TRAN_DAT	8     /* Transfer data from memory to array */
#define 	SET_TIMER	9     /* Set 8254 timer for pacer */
#define 	TRG_SLOPE	10    /* Trigger slope setting */
#define 	DO_BYTE 	11    /* Digit out */
#define 	DI_BYTE 	12    /* Digit in */
#define 	NADCG_INT	13    /* N Adc Group collecting on interrupt */

/*   ķ
 *    SUB FUNCTION NO. DEFINITION 
 *   Ľ
 */

#define 	RISE_EDGE	0     /* Rising edge mode */
#define 	FALL_EDGE	1     /* Falling edge mode */
#define 	EXT_TRG 	0     /* External trigger mode */
#define 	TIMER_TRG	1     /* Pacer trigger mode */
#define 	ONE_CYC 	0     /* One cycle */
#define 	RE_CYC		1     /* Recycle */
