/*   ͻ
 *   	Program  : DIOB.C						  
 *   	Revision : 1.0							  
 *   	Date	 : 11/10/90			   AXIOMTEK Tech. Co., Ltd.  
 *   Ķ
 *   	Purpose  : This demo program perform 8 bits Digit out and	  
 *   		   Digit in by function INIT,DO_BYTE,DI_BYTE.		  
 *   	Remark	 : Please connect DO channels to DI'S respectively        
 *   ͼ
 */

#include	"ax5210.h"
#define 	IOPORT		0x300	/* AX5210 Ioport */
int		fun,flag;
unsigned int	dio[7];
int far 	*ary1;
int far 	*ary2;

main()
{
	int	tmp1,tmp2,i,pat;

/* ķ
    INITIAL AX5210	
   Ľ */
	fun=INIT;		/* Initial function */
	dio[0]=IOPORT;		/* Ioport set */
	dio[1]=3;		/* IRQ NO. */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0)
	{
		printf (" DRIVER INITIALIZATION FAILED !,flag=%d\n",flag);
		exit(1);
	}

/* ķ
    Digit out 
   Ľ */
	printf("Please connect digit out channels to digit in ones repectively\n");
	printf("Key pattern (0 - FF)?");
	scanf("%x",&pat);
	fun = DO_BYTE;		/* Digit out function */
	dio[0] =pat;		/* Digit out pattern */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0) printf (" Digit out error !,flag=%d\n",flag);
	printf("Digit out = %x \n",dio[0]);

/* ķ
    DIGIT IN 
   Ľ */
	fun = DI_BYTE;		/* Digit in function */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0) printf (" Digit in error !,flag=%d\n",flag);
	printf("Digit in  = %x \n",dio[0]);

}
