/*   ͻ
 *     Program  : DIR_IO.C                                               
 *     Revision : 1.0                                                    
 *     Date     : 11/10/90                        AXIOMTEK Tech. Co., Ltd.  
 *   Ķ
 *     Purpose  : This demo program perform one channel A/D conversion   
 *                on software trigger by controling I/O port directly.   
 *   ͼ
 */

#include        <dos.h>
#define         IOPORT          0x300    /* AX5210 Ioport */

main()
{
        int     start_ch, stop_ch, ch, dat, dat_h, dat_l, i, j;

/* ķ
    INITIAL AX5210     
   Ľ */
        outp(IOPORT+2, 1);      /* Write 0x01 pattern to control register */
        i=inp(IOPORT+2);
        if ((i & 1) == 0)
            printf("ax5210 not exist\n");
        outp(IOPORT+2, 2);      /* Write 0x02 pattern to control register */
        i=inp(IOPORT+2);
        if ((i & 2) == 0)
            printf("ax5210 not exist\n");

/* ķ
    SET START & STOP CHANNEL 
   Ľ */
        printf ("ENTER START CHANNEL NUMBER <S/E--0...15>");
        scanf ("%d",&start_ch);
        printf ("ENTER STOP  CHANNEL NUMBER <S/E--0...15>");
        scanf ("%d",&stop_ch);
        j=start_ch;
        outp(IOPORT+2,0);       /* enable software trigger mode */

/* ķ
    SOFTWARE TRIGGER 
   Ľ */
        do {
           outp(IOPORT+1,j);    /* set channel */
           for (i=0; i<10000; i++) ;
           outp(IOPORT,0);      /* software trigger */
           while ((i=inp(IOPORT+2) & 0x08) != 0);       /* EOC = 0 ADC ready */
           dat_l=inp(IOPORT);
           dat_h=inp(IOPORT+1);
           ch=(dat_l & 0x0f);
           dat=(dat_h << 4) + (dat_l >> 4);
           dat -= 2048;
           printf("\n     CHANNEL %d\n     READING %d\n " ,ch,dat);
           printf(" PRESS ANY KEY TO CONVERT ANOTHER CHANNEL, <e> TO EXIT \n");
           if (++j > stop_ch)
              j = start_ch;
        } while (getche() != 'e');
}
