/*   ͻ
 *     Program  : SFT_TRG.C                                              
 *     Revision : 1.0                                                    
 *     Date     : 11/10/90                        AXIOMTEK Tech. Co., Ltd.  
 *   Ķ
 *     Purpose  : This demo program perform one channel A/D conversion   
 *                with software trigger by function INIT,SET_CH,SET_GAIN 
 *                ,SFT_TRG.                                              
 *   ͼ
 */

#include        "ax5210.h"
#define         IOPORT          0x300  /* AX5210 Ioport  */
int             fun,flag;
unsigned int    dio[7];
int far         *ary1;
int far         *ary2;

main()
{
        int     start_ch, stop_ch, i;

/* ķ
    INITIAL AX5210     
   Ľ */
        fun=INIT;               /* Initial function */
        dio[0]=IOPORT;          /* Ioport set */
        dio[1]=3;               /* IRQ NO. */
        flag=ax5210(fun,dio,ary1,ary2);
        if (flag != 0) {
                printf (" DRIVER INITIALIZATION FAILED !,flag=%d\n",flag);
                exit(1);
        }

/* ķ
    SET START & STOP CHANNEL 
   Ľ */
        printf ("ENTER START CHANNEL NUMBER <S/E--0...15>");
        scanf ("%d",&start_ch);
        printf ("ENTER STOP  CHANNEL NUMBER <S/E--0...15>");
        scanf ("%d",&stop_ch);
        fun=SET_CH;             /* Set channel function */
        dio[0]=start_ch;        /* Start channel set */
        dio[1]=stop_ch;         /* Stop  channel set */
        flag=ax5210(fun,dio,ary1,ary2);
        if (flag !=0 ) {
                printf ("SET SCAN CHANNEL FAILED ! RE-ENTER");
                exit(1);
        }

/* ķ
    SET GAIN FOR ALL CHANNEL 
   Ľ */
        for (i=0; i<16; i++) {
                fun=SET_GAIN;   /* Set gain function */
                dio[0]=i;       /* Set channel */
                dio[1]=1;       /* Set gain */
                flag=ax5210(fun,dio,ary1,ary2);
                if (flag != 0) {
                        printf ("SET GAIN FAILED!,FLAG=%d\n",flag);
                        exit(1);
                }
        }

/* ķ
    SOFTWARE TRIGGER 
   Ľ */
        do {
           fun=SFT_TRG;         /* Software trigger function */
           flag=ax5210(fun,dio,ary1,ary2);
           if (flag != 0) {
                printf("A/D CONVERSION FAILED !" );
                exit(1);
           }
           printf("\n     CHANNEL %d\n     DATA    %d\n " ,dio[1],dio[0]);
           printf(" PRESS ANY KEY TO CONVERT NEXT CHANNEL, <e> TO EXIT \n");
        } while (getche() != 'e');
}
